/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
hli@hendriklipka.de
*/

package de.hendriklipka.util;

import java.util.Vector;

public class Timer extends Thread
{
    protected long Ticks=0;
    protected long correctedTicks=0;
    protected Vector ObjList=new Vector(2,2);
    
    public Timer (long ticks)
    {
        Ticks=ticks;
        setDaemon(true);
    }
    
    public void run()
    {
        setPriority(Thread.MAX_PRIORITY);
        correctedTicks=Ticks;
        Object o=new Object();
        while (true)
        {
            synchronized (o)
            {
                long startTime=System.currentTimeMillis();
                try
                {
                    o.wait(correctedTicks);
                }
                catch (InterruptedException ex) {}
                for (int i=0;i<ObjList.size();i++)
                {
                    Object obj=ObjList.elementAt(i);
                    synchronized (obj)
                    {
                        try
                        {
                           obj.notifyAll();
                        }
                        catch (Exception ex) {}
                    }
                }
                long endTime=System.currentTimeMillis();
                long d=Ticks-(endTime-startTime);
                correctedTicks+=d;
                // if there are negative times, correct them into positive times
                // this could happen if the target thread does not release the wait object
                while (1>correctedTicks)
                {
                    correctedTicks+=Ticks;
                }
            }
        }
    }
    
    public void addThreadObject(Object o)
    {
        ObjList.addElement(o);
    }
}
